
Testing - Feature # 81

Status: Resolved Priority: Must have
Author: Robert Lemke Category:
Created: 2007-12-19 Assigned To: Karsten Dambekalns
Updated: 2011-05-06 Due date:
Subject: Improve component manager separation in Base Test Case
Description

Currently all tests get a complete copy (including subobjects) of the component manager injected. This happens in
source:Packages/Testing/Classes/T3_Testing_BaseTestCase.php#398 . However, the serialize / unserialize method will surely cause
problems as soon as we have persistence in place, so we need a finer grained solution here.

The problem is that some unit tests do change component configuration or even package configuration. This needs to be isolated from
other tests.

Associated revisions
Revision 50ee70ae - 2008-03-18 12:14 - Robert Lemke

    -  FLOW3: Added new folders and files to the global /Configuration directory
    -  FLOW3: Added new sections to the documentation (FLOW3 Bootstrap and Cache).
    -  FLOW3: Implemented a finer grained, improved bootstrap within the FLOW3 class. The boot sequence now consists of different initialization levels
which assert that initialization on higher levels can only be done if lower levels have been initialized and once initialized, a level can't be initialized
again.
    -  FLOW3: Added new (yet quite empty) sections to the manual.
    -  FLOW3: (Package) Moved the component configuration functions to the FLOW3 class.
    -  FLOW3: (Error) The exception handler now shows the beginning and the ending of an argument value (instead of only the beginning) if it is longer
than 40 characters.
    -  FLOW3: (AOP) Had to remove the getAspectContainers() method again because it conflicted with caching. If we really need this function, it can be
reimplemented, but it will only work if proxy caching is disabled.
    -  FLOW3: (Utility) Made sure that paths returned by getPathToTemporaryDirectory() end with a slash as defined in DIRECTORY_SEPARATOR
    -  TYPO3CR: Made the StorageAccess_PDOTest use a temporary directory instead of the private file cache
    -  Testing: Improved the cloning of the component manager by switching from unserialize(serialize()) to "clone". Addresses #81 (but maybe doesn't
complete solve it).

History
#1 - 2008-01-08 13:10 - Karsten Dambekalns

Err, why does it unserialize(serialize(...))?

#2 - 2008-01-08 13:35 - Robert Lemke

Because unserialize(serialize()) will create a copy of the object recursively while clone would only copy the component manager and not its related
objects.

#3 - 2008-01-08 13:46 - Karsten Dambekalns

Ok, guessed that already a minute ago and verified it's needed to make everything work as expected.
One problem I already had with the used method is that it (sometimes) runs out of memory (currently using memory_limit of 128MB here).

#4 - 2008-01-08 19:42 - Malte Jansen

Perhaps some variables could be unset in some classes, which are not needed anymore after there usage (especially if the classObject is stored
tempoarly).

Until now this solved the problem for the TYPO3CGL, which works in simluar ways to the Testing-Package with PHPUnit. The TYPO3CGL still works
with less than 32MB of memory. Before unsetting some variables it was more than 64MB.

#5 - 2008-07-01 17:03 - Karsten Dambekalns
- Target version deleted (1)

#6 - 2009-01-09 18:09 - Karsten Dambekalns

This one will be solved by simply not providing any part of FLOW3 to the BaseTestCase and making sure all tests use mocked versions of the needed
components. I started refactoring tests towards that goal late last year and we'll continue to do so, at least for FLOW3, TYPO3CR and other core
parts.

To make sure your tests run in the future, make sure to never use the provided $this->objectManager in your testcases.

#7 - 2009-01-09 18:10 - Karsten Dambekalns
- Status changed from New to Accepted
- Assigned To deleted (Karsten Dambekalns)
- Priority changed from Should have to Must have

#8 - 2010-12-20 16:06 - Karsten Dambekalns
- Status changed from Accepted to Resolved
- Assigned To set to Karsten Dambekalns
- Target version set to 1.0 alpha 14

No more $this->objectManager for unit tests has been reality for quite a while now...

#9 - 2010-12-20 16:06 - Karsten Dambekalns
- % Done changed from 0 to 100

#10 - 2011-05-06 11:25 - Karsten Dambekalns
- Target version deleted (1.0 alpha 14)
